pro special_movie,  index,  data,  r, g, b, movie_name=movie_name, $
     debug=debug,  _extra=_extra, movie_dir=movie_dir, $
     movie_text=movie_text, grid_minutes=grid_minutes, nolabel=nolabel
;+
;   Name: special_movie
;
;   Purpose: make sxt movies for WWW (just set up and call image2movie)
;
;   Input Parameters:
;      index - time structures (any SSW format)     
;      data  - 3D array
;
;   History:
;      10-July-1996 (S.L.Freeland)
;      25-July-1996 (S.L.Freeland) - broke html -> mk_movie_html
;      21-aug-1997  (S.L.Freeland) - new technol (image2movie.pro)
;      21-oct-1997  (S.L.Freeland) - keywords->image2movie (inheritance)
;       8-Apr-1998  (S.L.Freeland) - add /NONLABEL switch
;-
debug=keyword_set(debug)

if n_elements(movie_name) eq 0 then movie_name='special_'+ time2file(index(0))

; --------------------- set up device/path ----------------
dtemp=!d.name
set_plot,'z'
if not keyword_set(movie_dir) then movie_dir =concat_dir('$path_http','movies')
tempdir=curdir()
cd,movie_dir
hdoc=concat_dir(movie_dir,movie_name+'.html')
; -----------------------------------------------------------

; ----------------- initialize ------------------------------------
tindex=index
allhtml=''
newhtml=''
mroot=movie_name
message,/info,"Generating movie : " + movie_name
if keyword_set(grid_minutes) then begin           
   ss=grid_data(index,min=grid_minutes,/ss)
   index=index(ss)
   data=data(*,*,ss)
endif  
; -----------------------------------------------------------

quality_filter, index, data                  ; filter out bad frames

mtype=str2arr('java,gif,mpeg')             ; formats to include

; ----- generate movies, one  per mtype via image2movie.pro -------------
if not keyword_set(nolabel) then $
   label=anytim(index,out='ECS')

for i=0, n_elements(mtype)-1 do begin
   image2movie,data,r,g,b,  $
       movie_name=concat_dir(movie_dir,mroot+'_'+strmid(mtype(i),0,1)), $
       uttimes=index, label=lable, /inctime, thumbsize=100, $
       _extra=_extra, html=html, $
       java=(mtype(i) eq 'java'), mpeg=(mtype(i) eq 'mpeg'), $, $
       loop=(mtype(i) eq 'gif'),  gif=(mtype(i) eq 'gif')
   newhtml=[newhtml,html]
endfor 
; -----------------------------------------------------------

;  ----------- reformat HTML for 3 format table -----------------
thumb=strextract(newhtml(2),'<IMG SRC','>',/include)
head=[newhtml(1),strextract(newhtml(2),'Fram','<br>',/inc) ,thumb,'<br>']
movurls=strsplit(newhtml([2,4,6]),'Frame Size')+'</B></A>'
allhtml=[allhtml, $
	 '<table border=5><tr align=center><td>',head, $
         strtab2html(movurls),'</td></tr></table><p>']

if data_chk(movie_text,/string) then begin
   if file_exist(movie_text(0)) then movie_text=rd_tfile(movie_text)
   allhtml=[str2html(movie_text), allhtml]
endif

;  ------------- write an html document ----------------
html_doc,hdoc,/header
file_append,hdoc,allhtml
html_doc,hdoc,/trailer
;  ------------------------------------------------------

prstr,strjustify(['Completed HTML, URL:',http_names(hdoc)],/box)
index=tindex
if debug then stop
set_plot,dtemp
cd,tempdir
return
end
